﻿using System;

namespace Sortowanie
{
    public class Movie : IComparable<Movie>
    {
        #region Private members
        private int _id;
        private string _title;
        private string _director;
        private int _year;
        private string _genre;
        #endregion

        #region Public members
        public int ID
        {
            get { return _id; }
            set { _id = value; }
        }

        public string Title
        {
            get { return _title; }
            set { _title = value; }
        }

        public string Director
        {
            get { return _director; }
            set { _director = value; }
        }

        public string Genre
        {
            get { return _genre; }
            set { _genre = value; }
        }

        public int Year
        {
            get { return _year; }
            set { _year = value; }
        }
        #endregion

        #region Constructor
        public Movie(int id, string title, string director, string genre, int year)
        {
            _id = id;
            _title = title;
            _director = director;
            _genre = genre;
            _year = year;
        }
        #endregion

        #region IComparable
        public int CompareTo(Movie other)
        {
            return this.ID.CompareTo(other.ID);
        }
        #endregion

        #region Comparision - anonymous methods
        public static Comparison<Movie> IDComparison =
                                            delegate(Movie x, Movie y)
                                            {
                                                return x.ID.CompareTo(y.ID);
                                            };

        public static Comparison<Movie> TitleComparison =
                                            delegate(Movie x, Movie y)
                                            {
                                                return x.Title.CompareTo(y.Title);
                                            };
        #endregion

        #region Comparision
        public static int DirectorComparison(Movie x, Movie y)
        {
            return x.Director.CompareTo(y.Director);
        }

        public static int GenreComparison(Movie x, Movie y)
        {
            return x.Genre.CompareTo(y.Genre);
        }

        public static int YearComparison(Movie x, Movie y)
        {
            return x.Year.CompareTo(y.Year);
        }
        #endregion

        #region Methods
        public override string ToString()
        {
            return string.Format("ID: {0}, Name: {1}, Director: {2}, Genre: {3}, Year: {4}", _id, _title, _director, _genre, _year);
        }
        #endregion
    }
}
