﻿using System;
using System.Collections.Generic;

namespace Sortowanie
{
    class Program
    {
        static void Main(string[] args)
        {
            var movies = new List<Movie>();
            movies.Add(new Movie(4, "Szeregowiec Ryan", "Steven Spielberg", "Dramat", 1998));
            movies.Add(new Movie(1, "Patriota", "Roland Emmerich", "Akcja", 2000));
            movies.Add(new Movie(3, "Forest Gump", "Robert Zemeckis", "Komedia", 1994));
            movies.Add(new Movie(2, "Regulamin zabijania", "William Friedkin", "Thriller", 2000));
            
            PrintMovies(movies, "Filmy nieposortowane");

            movies.Sort();
            PrintMovies(movies, "Sortowanie za pomocą IComparable (ID)");

            movies.Sort(new MovieCompareByTitle());
            PrintMovies(movies, "Sortowanie za pomocą IComparer (Title)");

            movies.Sort(2, 2, new MovieCompareByYear());
            PrintMovies(movies, "Sortowanie za pomocą IComparer (Year - elementy 3 i 4)");

            movies.Sort(delegate(Movie x, Movie y)
                        {
                            return x.Genre.CompareTo(y.Genre);
                        });
            PrintMovies(movies, "Sortowanie za pomocą Comparision (Genre - metoda anonimowa)");

            movies.Sort(CompareByDirector);
            PrintMovies(movies, "Sortowanie za pomocą Comparision (Director - metoda w Main)");

            movies.Sort(Movie.TitleComparison);
            PrintMovies(movies, "Sortowanie za pomocą Comparision (Title - metoda anonimowa w klasie Movie)");

            movies.Sort(Movie.YearComparison);
            PrintMovies(movies, "Sortowanie za pomocą Comparision (Year - metoda klasy Movie)");

            Console.ReadLine();
        }

        private static int CompareByDirector(Movie x, Movie y)
        {
            return x.Director.CompareTo(y.Director);
        }

        private static void PrintMovies(List<Movie> movies, string info)
        {
            Console.WriteLine(info);
            foreach (var movie in movies)
            {
                Console.WriteLine(movie);
            }
            Console.WriteLine("--------------------------------------");
        }

    }
}
